/**
 * @file strategy.cpp
 *
 * @author Jan Hadrava
 * @date 2004
 * @ingroup iopclibcache
 */

//#include <malloc.h>

#include "../databaseObject.h"
#include "cache.h"
#include "strategy.h"

namespace iopc {

DLL_EXTERNAL class Strategy Strategy::eager(true, false, USImmed, RSDatabase);
DLL_EXTERNAL class Strategy Strategy::lazy(true, false, USDeferred, RSCache);
DLL_EXTERNAL class Strategy Strategy::async(true, false, USAsync, RSCache);
DLL_EXTERNAL class Strategy Strategy::xAccess(true, true, USDeferred, RSCache);
DLL_EXTERNAL class Strategy &Strategy::defaultStrategy = Strategy::lazy;

Strategy::Strategy(bool loadWait, bool loadLocking,
	enum UpdatingStrategy uStrat, enum ReadingStrategy rStrat,
	void *wakeUpData, WakeUpMntrFunction wakeUpFunction, CostFunction costFunction)
: loadWait(loadWait), loadLocking(loadLocking),
	uStrat(uStrat), rStrat(rStrat), wakeUpData(wakeUpData), wakeUpFunction(wakeUpFunction), costFunction(costFunction)
{
}

Strategy::~Strategy()
{
}

long Strategy::memoryCost(DatabaseObject& obj)
{
	return obj.getMemCost();
}

long Strategy::constCost(DatabaseObject& obj)
{
	return 1;
}


}/*namespace polite*/
