#include "mappingStrategy.h"
#include "../databaseObject.h"
#include "iopcdb/cursor.h"
#include "../keyValues.h"
#include "../oidObject.h"
#include "dbType.h"

using namespace std;
using namespace iopc;

void MappingStrategy::mapKeyAttributes(Cursor* cur, int startIndex, DatabaseObject& obj)
{
	int i = startIndex;
	for (DbType::KeyAttributesIterator it = getDbType().getKeyAttributes().begin(); it != getDbType().getKeyAttributes().end(); it++)
	{
		const AttributeValue& attrVal = obj.getAttributeValue((*it)->getName());
		cur->addInParam(i, attrVal.getValue(), attrVal.getAttribute().getType(), (MetadataHolder&) *(*it));
		i++;
	}
}

void MappingStrategy::mapKeyAttributes(Cursor* cur, int startIndex, const KeyValues& keyVals)
{
	int i = startIndex;

	for (DbType::KeyAttributesIterator it = getDbType().getKeyAttributes().begin(); it != getDbType().getKeyAttributes().end(); it++)
		{
			IOPC_DEBUGLOG(string("BindIn [") + (*it)->getName() + string("] ") + keyVals.get((*it)->getName()).toString());
			cur->addEnhancedInParam(i, keyVals.get((*it)->getName()), (MetadataHolder&) getType().getAttributeAll((*it)->getName()));

			i++;
		}
}

void MappingStrategy::mapKeyAttributes(Cursor* cur, int startIndex, const OidType& oid)
{
	int i = startIndex;
	cur->addInParam(i, &oid, TypeDesc<OidType>::getType(), TypeDesc<OidObject>::getType().getAttributeAll("oid"));
}
