CONFIGURATION=Debug
export LD_LIBRARY_PATH=../../iopccommon/$CONFIGURATION

# prepare the arguments
INFILE=`echo "$*" | sed "s;.*@in\(.*\)@in.*;\1;"`
OUTFILE=`echo "$*" | sed "s;.*@out\(.*\)@out.*;\1;"`
FLAGS=`echo "$*" | sed "s;.*@flags\(.*\)$;\1;"`
OUT=`echo "$OUTFILE" | sed "s;\(.*\).o;\1;"`
OUTCXML=$OUT.cxml
OUTIC=$OUT.ic
OUTIH=$OUT.ih
OUTICO=$OUT.ic.o
# process flags (remove -c)
GCCXMLFLAGS=`echo "$FLAGS" | sed "s;-c;;"`

#echo ***
#echo Infile: $INFILE
#echo Outfile: $OUTFILE
#echo Flags: $FLAGS
#echo OutCXML: $OUTCXML
#echo OutIC: $OUTIC
#echo GccXMLFLags: $GCCXMLFLAGS
#echo ***

#run GCCXML on the input file
echo "gccxml $GCCXMLFLAGS $INFILE -fxml=$OUTCXML"
gccxml $GCCXMLFLAGS $INFILE -fxml=$OUTCXML
if [ ! -e "$OUTCXML" ]; then
	echo "Error exitprocessing file $INFILE"
	exit 1
fi

#run iopcsp on the gccxml output
echo "../../iopcsp $OUTCXML $OUT"
../../iopcsp/$CONFIGURATION/iopcsp $OUTCXML $OUT
if [ ! -e "$OUTIC" ]; then
	echo "Error running iopcsp on $OUTCXML"
	exit 1
fi

#build the type library
echo "gcc -x c++ $FLAGS -c $OUTIC -o $OUTICO"
gcc -x c++ $FLAGS -c $OUTIC -o $OUTICO
if [ ! -e "$OUTICO" ]; then
	echo "Error compiling the type library from $OUTIC"
	exit 1
fi

# add the type library to the type library archive
echo "ar -r typedir.a $OUTICO"
ar -r typedir.a $OUTICO

#build the module
echo "gcc $FLAGS -o $OUTFILE $INFILE"
gcc $FLAGS -o $OUTFILE $INFILE
if [ ! -e "$OUTICO" ]; then
	echo "Error compiling the module $OUTFILE"
	exit 1
fi

# rm $OUTIC $OUTIH $OUTCXML

# rm $FILENAME.o $FILENAME.ic.o $FILENAME.cxml $FILENAME.ic $FILENAME.ih
